/**
 * This is the main dio test program file
 * It starts a cog 
 */
#include <stdio.h>
#include <unistd.h>
#include <propeller.h>
#include "cog_test.h"

//#include "simpletools.h"
                      
/* control block for cogA */
static struct {
    unsigned stack[STACK_SIZE_A];
    volatile struct cogA_mailbox mb;
}cbA;
 
/* start cogA */
int startA(volatile void *cb)
{
    extern unsigned int _load_start_cogA_cog[];
    return load_cog_driver_xmm(_load_start_cogA_cog, 496, (uint32_t *)cb);
}

void get_cog_message(char *mb, volatile struct cogA_mailbox *m)
{
    int             i;
    for(i=0;i<COG_MESSAGE_SIZE;i++) mb[i] = '\0';
    while(lockset(cbA.mb.message_lock_ID));
    if(m->message_flag==1){
        strcpy(mb,(char *)m->message);
        m->message_flag=0;
    }
    lockclr(cbA.mb.message_lock_ID);
    return;
}

int main(void)
{
    static char            mb[128]; 
    int             i,ii;
/* get lock id */
    cbA.mb.message_lock_ID = locknew();
    lockclr(cbA.mb.message_lock_ID);
/* start the A cog */
    printf("startA returned %i\n\n",startA(&cbA.mb));
    get_cog_message(mb,&cbA.mb);
    if(*mb != '\0')
        printf(" <%s>\n",mb);
    get_cog_message(mb,&cbA.mb);
    if(*mb != '\0')
        printf(" <%s>\n",mb);

    for(i=0;i<2;i++){
        for(ii=0;ii<256;ii++){
            cbA.mb.ccb=(uint8_t)ii;
            printf("byte <%02x>\n",cbA.mb.ccb);
            sleep(1);
            get_cog_message(mb,&cbA.mb);
            if(*mb != '\0')
                printf(" <%s>\n",mb);
        }
        sleep(2);
    }
    return 0;
}



